/*
 =================== DO NOT EDIT THIS FILE ====================
 Generated by Modello 1.6 on 2013-02-11 11:33:40,
 any modifications will be overwritten.
 ==============================================================
 */

package org.sonatype.nexus.configuration.model.v1_0_2;

/**
 * The root element of Nexus configuration.
 * 
 * @version $Revision$ $Date$
 */
@SuppressWarnings( "all" )
public class Configuration
    implements java.io.Serializable
{

      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * 
     *             The version of the persisted model. Should be
     * equal to the version in Nexus that consumes this
     *             configuration.
     *           
     */
    private String version = "1.0.2";

    /**
     * 
     *             The Nexus workingDirectory contains files needed
     * for Nexus to function properly. Data like
     *             Lucene
     *             index, file
     *             attributes, shared local storage, etc. are here.
     *           
     */
    private String workingDirectory = "${basedir}/nexus-work";

    /**
     * 
     *             The Nexus logDirectory should contain log files
     * created by Nexus during work.
     *           
     */
    private String applicationLogDirectory = "${basedir}/logs";

    /**
     * This section defines Nexus security.
     */
    private CSecurity security;

    /**
     * 
     *             The global connection settings are settings
     * applied across Nexus. These can be overridden by
     *             per-repository connection
     *             settings.
     *           
     */
    private CRemoteConnectionSettings globalConnectionSettings;

    /**
     * 
     *             The global HTTP Proxy settings are settings
     * applied across Nexus. These can be overridden by
     *             per-repository HTTP Proxy
     *             settings.
     *           
     */
    private CRemoteHttpProxySettings globalHttpProxySettings;

    /**
     * The Nexus REST settings.
     */
    private CRestApiSettings restApi;

    /**
     * The Nexus HTTP Proxy settings.
     */
    private CHttpProxySettings httpProxy;

    /**
     * The routing settings alters the way Nexus routers will do
     * they work.
     */
    private CRouting routing;

    /**
     * Field repositories.
     */
    private java.util.List<CRepository> repositories;

    /**
     * Field repositoryShadows.
     */
    private java.util.List<CRepositoryShadow> repositoryShadows;

    /**
     * The repository grouping within Nexus.
     */
    private CRepositoryGrouping repositoryGrouping;

    /**
     * Field remoteNexusInstances.
     */
    private java.util.List<CRemoteNexusInstance> remoteNexusInstances;

    /**
     * Field modelEncoding.
     */
    private String modelEncoding = "UTF-8";


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method addRemoteNexusInstance.
     * 
     * @param cRemoteNexusInstance
     */
    public void addRemoteNexusInstance( CRemoteNexusInstance cRemoteNexusInstance )
    {
        getRemoteNexusInstances().add( cRemoteNexusInstance );
    } //-- void addRemoteNexusInstance( CRemoteNexusInstance )

    /**
     * Method addRepository.
     * 
     * @param cRepository
     */
    public void addRepository( CRepository cRepository )
    {
        getRepositories().add( cRepository );
    } //-- void addRepository( CRepository )

    /**
     * Method addRepositoryShadow.
     * 
     * @param cRepositoryShadow
     */
    public void addRepositoryShadow( CRepositoryShadow cRepositoryShadow )
    {
        getRepositoryShadows().add( cRepositoryShadow );
    } //-- void addRepositoryShadow( CRepositoryShadow )

    /**
     * Get the Nexus logDirectory should contain log files created
     * by Nexus during work.
     * 
     * @return String
     */
    public String getApplicationLogDirectory()
    {
        return this.applicationLogDirectory;
    } //-- String getApplicationLogDirectory()

    /**
     * Get the global connection settings are settings applied
     * across Nexus. These can be overridden by
     *             per-repository connection
     *             settings.
     * 
     * @return CRemoteConnectionSettings
     */
    public CRemoteConnectionSettings getGlobalConnectionSettings()
    {
        return this.globalConnectionSettings;
    } //-- CRemoteConnectionSettings getGlobalConnectionSettings()

    /**
     * Get the global HTTP Proxy settings are settings applied
     * across Nexus. These can be overridden by
     *             per-repository HTTP Proxy
     *             settings.
     * 
     * @return CRemoteHttpProxySettings
     */
    public CRemoteHttpProxySettings getGlobalHttpProxySettings()
    {
        return this.globalHttpProxySettings;
    } //-- CRemoteHttpProxySettings getGlobalHttpProxySettings()

    /**
     * Get the Nexus HTTP Proxy settings.
     * 
     * @return CHttpProxySettings
     */
    public CHttpProxySettings getHttpProxy()
    {
        return this.httpProxy;
    } //-- CHttpProxySettings getHttpProxy()

    /**
     * Get the modelEncoding field.
     * 
     * @return String
     */
    public String getModelEncoding()
    {
        return this.modelEncoding;
    } //-- String getModelEncoding()

    /**
     * Method getRemoteNexusInstances.
     * 
     * @return List
     */
    public java.util.List<CRemoteNexusInstance> getRemoteNexusInstances()
    {
        if ( this.remoteNexusInstances == null )
        {
            this.remoteNexusInstances = new java.util.ArrayList<CRemoteNexusInstance>();
        }

        return this.remoteNexusInstances;
    } //-- java.util.List<CRemoteNexusInstance> getRemoteNexusInstances()

    /**
     * Method getRepositories.
     * 
     * @return List
     */
    public java.util.List<CRepository> getRepositories()
    {
        if ( this.repositories == null )
        {
            this.repositories = new java.util.ArrayList<CRepository>();
        }

        return this.repositories;
    } //-- java.util.List<CRepository> getRepositories()

    /**
     * Get the repository grouping within Nexus.
     * 
     * @return CRepositoryGrouping
     */
    public CRepositoryGrouping getRepositoryGrouping()
    {
        return this.repositoryGrouping;
    } //-- CRepositoryGrouping getRepositoryGrouping()

    /**
     * Method getRepositoryShadows.
     * 
     * @return List
     */
    public java.util.List<CRepositoryShadow> getRepositoryShadows()
    {
        if ( this.repositoryShadows == null )
        {
            this.repositoryShadows = new java.util.ArrayList<CRepositoryShadow>();
        }

        return this.repositoryShadows;
    } //-- java.util.List<CRepositoryShadow> getRepositoryShadows()

    /**
     * Get the Nexus REST settings.
     * 
     * @return CRestApiSettings
     */
    public CRestApiSettings getRestApi()
    {
        return this.restApi;
    } //-- CRestApiSettings getRestApi()

    /**
     * Get the routing settings alters the way Nexus routers will
     * do they work.
     * 
     * @return CRouting
     */
    public CRouting getRouting()
    {
        return this.routing;
    } //-- CRouting getRouting()

    /**
     * Get this section defines Nexus security.
     * 
     * @return CSecurity
     */
    public CSecurity getSecurity()
    {
        return this.security;
    } //-- CSecurity getSecurity()

    /**
     * Get the version of the persisted model. Should be equal to
     * the version in Nexus that consumes this
     *             configuration.
     * 
     * @return String
     */
    public String getVersion()
    {
        return this.version;
    } //-- String getVersion()

    /**
     * Get the Nexus workingDirectory contains files needed for
     * Nexus to function properly. Data like
     *             Lucene
     *             index, file
     *             attributes, shared local storage, etc. are here.
     * 
     * @return String
     */
    public String getWorkingDirectory()
    {
        return this.workingDirectory;
    } //-- String getWorkingDirectory()

    /**
     * Method removeRemoteNexusInstance.
     * 
     * @param cRemoteNexusInstance
     */
    public void removeRemoteNexusInstance( CRemoteNexusInstance cRemoteNexusInstance )
    {
        getRemoteNexusInstances().remove( cRemoteNexusInstance );
    } //-- void removeRemoteNexusInstance( CRemoteNexusInstance )

    /**
     * Method removeRepository.
     * 
     * @param cRepository
     */
    public void removeRepository( CRepository cRepository )
    {
        getRepositories().remove( cRepository );
    } //-- void removeRepository( CRepository )

    /**
     * Method removeRepositoryShadow.
     * 
     * @param cRepositoryShadow
     */
    public void removeRepositoryShadow( CRepositoryShadow cRepositoryShadow )
    {
        getRepositoryShadows().remove( cRepositoryShadow );
    } //-- void removeRepositoryShadow( CRepositoryShadow )

    /**
     * Set the Nexus logDirectory should contain log files created
     * by Nexus during work.
     * 
     * @param applicationLogDirectory
     */
    public void setApplicationLogDirectory( String applicationLogDirectory )
    {
        this.applicationLogDirectory = applicationLogDirectory;
    } //-- void setApplicationLogDirectory( String )

    /**
     * Set the global connection settings are settings applied
     * across Nexus. These can be overridden by
     *             per-repository connection
     *             settings.
     * 
     * @param globalConnectionSettings
     */
    public void setGlobalConnectionSettings( CRemoteConnectionSettings globalConnectionSettings )
    {
        this.globalConnectionSettings = globalConnectionSettings;
    } //-- void setGlobalConnectionSettings( CRemoteConnectionSettings )

    /**
     * Set the global HTTP Proxy settings are settings applied
     * across Nexus. These can be overridden by
     *             per-repository HTTP Proxy
     *             settings.
     * 
     * @param globalHttpProxySettings
     */
    public void setGlobalHttpProxySettings( CRemoteHttpProxySettings globalHttpProxySettings )
    {
        this.globalHttpProxySettings = globalHttpProxySettings;
    } //-- void setGlobalHttpProxySettings( CRemoteHttpProxySettings )

    /**
     * Set the Nexus HTTP Proxy settings.
     * 
     * @param httpProxy
     */
    public void setHttpProxy( CHttpProxySettings httpProxy )
    {
        this.httpProxy = httpProxy;
    } //-- void setHttpProxy( CHttpProxySettings )

    /**
     * Set the modelEncoding field.
     * 
     * @param modelEncoding
     */
    public void setModelEncoding( String modelEncoding )
    {
        this.modelEncoding = modelEncoding;
    } //-- void setModelEncoding( String )

    /**
     * Set the known remote nexus instances.
     * 
     * @param remoteNexusInstances
     */
    public void setRemoteNexusInstances( java.util.List<CRemoteNexusInstance> remoteNexusInstances )
    {
        this.remoteNexusInstances = remoteNexusInstances;
    } //-- void setRemoteNexusInstances( java.util.List )

    /**
     * Set the list of defined repositories within Nexus.
     * 
     * @param repositories
     */
    public void setRepositories( java.util.List<CRepository> repositories )
    {
        this.repositories = repositories;
    } //-- void setRepositories( java.util.List )

    /**
     * Set the repository grouping within Nexus.
     * 
     * @param repositoryGrouping
     */
    public void setRepositoryGrouping( CRepositoryGrouping repositoryGrouping )
    {
        this.repositoryGrouping = repositoryGrouping;
    } //-- void setRepositoryGrouping( CRepositoryGrouping )

    /**
     * Set the list of defined repository shadows within Nexus.
     * 
     * @param repositoryShadows
     */
    public void setRepositoryShadows( java.util.List<CRepositoryShadow> repositoryShadows )
    {
        this.repositoryShadows = repositoryShadows;
    } //-- void setRepositoryShadows( java.util.List )

    /**
     * Set the Nexus REST settings.
     * 
     * @param restApi
     */
    public void setRestApi( CRestApiSettings restApi )
    {
        this.restApi = restApi;
    } //-- void setRestApi( CRestApiSettings )

    /**
     * Set the routing settings alters the way Nexus routers will
     * do they work.
     * 
     * @param routing
     */
    public void setRouting( CRouting routing )
    {
        this.routing = routing;
    } //-- void setRouting( CRouting )

    /**
     * Set this section defines Nexus security.
     * 
     * @param security
     */
    public void setSecurity( CSecurity security )
    {
        this.security = security;
    } //-- void setSecurity( CSecurity )

    /**
     * Set the version of the persisted model. Should be equal to
     * the version in Nexus that consumes this
     *             configuration.
     * 
     * @param version
     */
    public void setVersion( String version )
    {
        this.version = version;
    } //-- void setVersion( String )

    /**
     * Set the Nexus workingDirectory contains files needed for
     * Nexus to function properly. Data like
     *             Lucene
     *             index, file
     *             attributes, shared local storage, etc. are here.
     * 
     * @param workingDirectory
     */
    public void setWorkingDirectory( String workingDirectory )
    {
        this.workingDirectory = workingDirectory;
    } //-- void setWorkingDirectory( String )

    
    public static final String LOCAL_STATUS_IN_SERVICE = "inService";

    public static final String LOCAL_STATUS_OUT_OF_SERVICE = "outOfService";

    
    public static final String MODEL_VERSION = "1.0.2";

}
